<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package GA4 Hyva Compatibility
 */
declare(strict_types=1);

namespace Amasty\GA4Hyva\CustomerData;

use Amasty\GA4\Model\Frontend\GA4Session;
use Magento\Customer\CustomerData\SectionSourceInterface;

class EventsPool implements SectionSourceInterface
{
    /** @var string  */
    public const EVENTS_DATA_KEY = 'eventsData';

    /** @var GA4Session */
    private GA4Session $session;

    /**
     * @param GA4Session $ga4Session
     */
    public function __construct(
        GA4Session $ga4Session
    ) {
        $this->session = $ga4Session;
    }

    /**
     * SectionData returns array with data for js component
     *
     * @return array[]
     */
    public function getSectionData(): array
    {
        if (!$this->session->hasEvents()) {
            return [];
        }

        return [
            'events' => array_values(
                $this->session->getEvents(true)
            )
        ];
    }
}
