<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package GA4 Hyva Compatibility
 */
declare(strict_types=1);

namespace Amasty\GA4Hyva\Plugin\CustomerData\EventPool;

use Amasty\GA4\CustomerData\EventPool;
use Hyva\Theme\Service\CurrentTheme;

class RemoveAmastySectionKey
{
    /** @var CurrentTheme  */
    private CurrentTheme $currentTheme;

    /**
     * @param CurrentTheme $currentTheme
     */
    public function __construct(
        CurrentTheme $currentTheme
    ) {
        $this->currentTheme = $currentTheme;
    }

    /**
     * Remove amasty section key from section data
     *
     * @param EventPool $subject
     * @param callable $proceed
     *
     * @return array
     */
    public function aroundGetSectionData(
        EventPool $subject,
        callable $proceed
    ): array {
        if ($this->currentTheme->isHyva()) {
            return [];
        }

        return $proceed();
    }
}
