<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package GA4 Hyva Compatibility
 */

namespace Amasty\GA4Hyva\Plugin\GA4\Model\Utils;

use Amasty\GA4\Model\Utils\ProductDetailsFormatter;
use Magento\Quote\Api\Data\CartItemInterface;

class PrepareCorrectCartItemPrice
{
    /**
     * Collect quote totals if cart item price is empty
     *
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     *
     * @param ProductDetailsFormatter $subject
     * @param CartItemInterface $cartItem
     * @param string $listId
     * @param string $listName
     * @param int|null $index
     * @return array
     */
    public function beforeFormatFromCartItem(
        ProductDetailsFormatter $subject,
        CartItemInterface $cartItem,
        string $listId = '',
        string $listName = '',
        ?int $index = null
    ): array {
        if ($cartItem->getPriceInclTax() === null) {
            $quote = $cartItem->getQuote();
            $quote->collectTotals();
            $quote->setTotalsCollectedFlag(false);
        }

        return [$cartItem, $listId, $listName, $index];
    }
}
